SystemOrganization addCategory: #Ajedrez!

SimpleSwitchMorph subclass: #GPixel
	instanceVariableNames: 'sizePixel mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 09:59'!
colorOn
	"Cambia el color del pixel a negro"

	self color: Color black  ! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 10:24'!
getSizePixel 
	"Returna el tamao del pixel"

	^sizePixel ! !

!GPixel methodsFor: 'initialization' stamp: 'yusenmanchego 10/13/2012 14:42'!
initialize 
	"Iniciamos la clase GPixel, creando un pixel como un cuadrado de tamao sizePixel y color blanco"

	super  initialize .
	sizePixel := 5 .
	bounds := (0@0) corner: (sizePixel@sizePixel).
	fullBounds := (0@0) corner: (sizePixel@sizePixel).
	color := Color white .
	borderWidth := 0.
	label := ''.
	self useSquareCorners .
	
	
! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 14:02'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 10:19'!
setSizePixel: newSize
	"cambia el tamao del cuadrado que representa el pixel"

	sizePixel := newSize ! !

RectangleMorph subclass: #AjPaintPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!AjPaintPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 13:13'!
initialize 
	"inicializamos un rectangulo donde se realizara el pintado de la imagen"

	super initialize .! !

!AjPaintPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:56'!
paint: picture
	"Dibuja en pantalla la imagen que recibe"

	| imagen ancho altura pixel origen pixelWidth pixelHeight |
	ancho := picture getWidth .
	altura := picture getHeight .
	imagen := picture getMatrix .

	pixel := AjPixel new.
	pixelWidth := pixel getWidth .
	pixelHeight := pixel getHeight .
	
		
	origen := self innerBounds origin .
	self bounds: (0@0 extent: (ancho*pixelWidth)@(altura * pixelHeight ) ) .
	
	1 to: altura do: [
		:i |  |cadena| 
		cadena := imagen at: i.
		1 to: ancho do: [
			:j |  | char |
			char := cadena at: j .
			pixel := AjPixel new.
			pixel colorear: char .
			self addMorph: pixel .
			pixel position: ( ( (j-1)*pixelWidth )@((i-1)*pixelHeight ))+origen .
			]
		]	
	! !

RectangleMorph subclass: #GPicture1
	instanceVariableNames: 'pic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPicture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 14:50'!
iniciar:  figura
	pic := figura.
	! !

!GPicture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 17:21'!
initialize 
	super initialize.
	self bounds: (0@0 extent:  62@62).! !

!GPicture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 17:16'!
paint
	|array n|
	array:=pic getimg .
	n:= array size.
	1 to: n do: [:j | self parseCadena: (array at:(n+1-j)) linea: j ]
	! !

!GPicture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 17:18'!
parseCadena:  cadena  linea:  n 
	| caracter tam punto origin|
	tam:= cadena size.
	origin := self innerBounds origin.
	1 to: tam do: [:j | punto:=Punto new. 
		self addMorph:  punto. 
		caracter:=cadena at:j. 
		self parseChar:caracter pixel:punto.  
		punto position: (j-1)@(n-1) + origin  ]! !

!GPicture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 14:40'!
parseChar: caracter pixel: pix
	|gray light_gray dark_gray a |
	gray:=Color r:0.5 g:0.5 b:0.5. 
	light_gray:=Color r:0.75 g:0.75 b:0.75. 
	dark_gray:=Color r:0.25 g:0.25 b:0.25. 
	"pix color: Color black."
	a='a'.
	Transcript cr; show:  caracter=$a.
	caracter = $_  ifTrue: [pix color: light_gray].
	caracter = $= ifTrue: [pix color: Color gray].
	caracter = $. ifTrue: [pix color: Color white].
	caracter = $@ ifTrue: [pix color: Color black].
	caracter = $# ifTrue: [pix color: dark_gray].
	caracter = $a value ifTrue: [pix color: Color yellow ].! !

Morph subclass: #AjPixel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!AjPixel methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:21'!
colorear: caracter
	"Colorea el pixel de acuerdo a la variable caracter "

	( caracter = $_  )  ifTrue: [color := AjColor grayLight ].
	( caracter = $=  ) ifTrue: [color := AjColor gray].
	( caracter = $.   ) ifTrue: [color := AjColor white].
	( caracter = $@ ) ifTrue: [color := AjColor black].
	( caracter = $#  ) ifTrue: [color := AjColor grayDark ].
! !

!AjPixel methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:27'!
getHeight
	"retornamos ancho de pixel"

	^ self height ! !

!AjPixel methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:26'!
getWidth 
	"retornamos ancho de pixel"

	^ self width ! !

!AjPixel methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 16:56'!
initialize 
	"creamos un pixel"

	super initialize.
	self width: 3.
	self height: 3.
	color := Color r:1 g:1 b:1 .! !

Morph subclass: #Punto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Punto methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/12/2012 14:41'!
initialize 

	super initialize.
	self width: 1.
	self height: 1.
	color := Color r:1 g:1 b:1 .! !

Color subclass: #AjColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!AjColor class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:02'!
gray 
	"Devuelve el color gray"

	^ ( Color r: 0.5 g: 0.5 b: 0.5 ) ! !

!AjColor class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:04'!
grayDark 
	"Devuelve el color gray dark"

	^ ( Color r: 0.25 g: 0.25 b: 0.25 ) ! !

!AjColor class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 14:03'!
grayLight
	"Devuelve el color gray light"

	^ ( Color r: 0.75 g: 0.75 b: 0.75 ) ! !

!AjColor methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 13:59'!
initialize 
	"Inicializa la clase padre Color"

	super initialize ! !

BorderedMorph subclass: #Contenedor
	instanceVariableNames: 'mensaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Contenedor methodsFor: 'as yet unclassified' stamp: 'david 10/12/2012 17:33'!
initialize
	| sampleCell width height n punto pos imagen gimagen origin|
	super initialize.
	self color: Color yellow.
	self bounds: (100@100 extent: 500@500).
	origin := self innerBounds origin.
	gimagen:=GPicture1 new.
	self addMorph: gimagen .
	gimagen position: 0@0+ origin .
	punto:=Punto new.
	imagen:= Picture1 rey .
	gimagen iniciar: imagen .
	gimagen paint .! !

BorderedMorph subclass: #GPicture
	instanceVariableNames: 'pixeles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPicture methodsFor: 'initialization' stamp: 'yusenmanchego 10/13/2012 13:03'!
initialize 
	"Inicializa la clase GPicture, creando una espacio para visualizar imagen"
	
	super initialize.


	
	
	! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 13:24'!
nuevoPixelX: i Y: j 
	"comment stating purpose of message"

	| pix origen|
	pix := GPixel new.
	origen := self innerBounds origin.
	self addMorph: pix.
	
	pix position: ((i - 1) * pix width) @ ((j - 1) * pix height) + origen.
	pix mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^pix
	! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 14:34'!
visualizar: picture
	"Muestra la imagen que le demos"
	| ancho altura pixel pSize|
	pixel := GPixel new.
	pSize := pixel getSizePixel .
	ancho  := picture size .	
	altura := (picture at:1) size .

	self bounds: (5@5 extent: ( (ancho*pSize)@(altura*pSize) )+(2 * self borderWidth)).
	pixeles :=Matrix rows: ancho  columns: altura tabulate: [ :i :j | self nuevoPixelX: i Y: j ].
	
	1 to: ancho do: [
		:i |  |cad| cad:=picture at: i.
		1 to: altura do: [
			:j | ($# =(cad at:j) ) ifTrue: [ (pixeles  at: i at: j ) colorOn ]
			]
		]! !

Object subclass: #AjPicture
	instanceVariableNames: 'matrix width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 19:00'!
alfil
	"Retorna la Figura de un alfil"
	
	| alfil |
	alfil   := AjPicture new.
	alfil   init: #(
'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                            ##                            ' 
		'                          ######                          ' 
		'                         ###..###                         ' 
		'                         ##....##                         ' 
		'                         ##....##                         ' 
		'                         ###..###                         ' 
		'                          ######                          ' 
		'                           ####                           ' 
		'                         ########                         ' 
		'                        ###....###                        ' 
		'                      ####......####                      ' 
		'                    ####..........####                    ' 
		'                   ###..............###                   ' 
		'                  ###................###                  ' 
		'                 ###..................###                 ' 
		'                ###.........##.........###                ' 
		'                ##..........##..........##                ' 
		'               ###..........##..........###               ' 
		'               ##...........##...........##               ' 
		'               ##.......##########.......##               ' 
		'               ##.......##########.......##               ' 
		'               ##...........##...........##               ' 
		'               ##...........##...........##               ' 
		'               ##...........##...........##               ' 
		'               ###..........##..........###               ' 
		'                ##..........##..........##                ' 
		'                ###....................###                ' 
		'                 ##....................###                ' 
		'                 ###..................###                 ' 
		'                  ###................###                  ' 
		'                   ####################                   ' 
		'                   ####################                   ' 
		'                   ##................##                   ' 
		'                  ###................###                  ' 
		'                  ##..................##                  ' 
		'                  ######################                  ' 
		'                 ########################                 ' 
		'                 ###..................###                 ' 
		'                 #####..............#####                 ' 
		'                 ########################                 ' 
		'                      ##############                      ' 
		'                          ######                          ' 
		'                        ####..####                        ' 
		'        ##################......##################        ' 
		'      ##################..........##################      ' 
		'    ####..........................................####    ' 
		'    ###.....................##.....................###    ' 
		'     ##...................######...................##     ' 
		'     ###.########.......####  ####.......########.###     ' 
		'      ####################      ####################      ' 
		'       ##        #######          #######        ##       ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '
	).	
	^alfil 
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 15:05'!
caballo
	"Retorna la Figura de un caballo"
	
	| caballo |
	caballo := AjPicture new.
	caballo init: #(
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'               #         ##                               ' 
		'              ###       ####                              ' 
		'              #####     ####                              ' 
		'               #####   ######                             ' 
		'               ##.### ###..##                             ' 
		'               ##..#####...######                         ' 
		'               ##...####...#########                      ' 
		'               ##..#####...##...######                    ' 
		'              ###.###.......#.....######                  ' 
		'             ###..#.................#####                 ' 
		'            ###.......................####                ' 
		'            ##.........................####               ' 
		'           ###..####....................####              ' 
		'           ##..####......................####             ' 
		'           ##..####......................#####            ' 
		'           ##..###........................####            ' 
		'          ###..#..............##...........####           ' 
		'          ##..................##...........####           ' 
		'          ##..................##............####          ' 
		'         ###..................##............####          ' 
		'         ##...................##.............####         ' 
		'        ###..................###.............####         ' 
		'       ###..................###..............####         ' 
		'      ###...................###...............####        ' 
		'      ##...................####...............####        ' 
		'     ###.................######...............####        ' 
		'     ##................####  ##................####       ' 
		'    ###.##...........####    ##................####       ' 
		'    ##.###.........####     ###................####       ' 
		'    ##.###........###       ##.................####       ' 
		'    ##.##........###       ###.................#####      ' 
		'    ##......##..###        ##...................####      ' 
		'    ##.....###.###        ###...................####      ' 
		'    ###...#######        ###....................####      ' 
		'     ########.##        ###.....................####      ' 
		'       #########       ###......................####      ' 
		'            ###       ###.......................#####     ' 
		'                     ###........................#####     ' 
		'                    ###..........................####     ' 
		'                    ##...........................####     ' 
		'                   ###...........................####     ' 
		'                  ###............................####     ' 
		'                  ##.............................####     ' 
		'                 ###.............................####     ' 
		'                 ##..............................####     ' 
		'                 ##..............................####     ' 
		'                 ####################################     ' 
		'                 ####################################     ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '
	).	
	^caballo
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 15:19'!
casilleroBlanco 
	"Retorna la Figura del casillero blanco"
	
	| casilleroBlanco |
	casilleroBlanco   := AjPicture new.
	casilleroBlanco init: #(
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________' 
		'__________________________________________________________'

	).	
	^casilleroBlanco 
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 15:13'!
peon
	"Retorna la Figura de un peon"
	
	| peon |
	peon  := AjPicture new.
	peon  init: #(
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                           ####                           ' 
		'                         ########                         ' 
		'                        ###....###                        ' 
		'                       ###......###                       ' 
		'                       ##........##                       ' 
		'                       ##........##                       ' 
		'                       ##........##                       ' 
		'                       ##........##                       ' 
		'                       ###......###                       ' 
		'                        ###....###                        ' 
		'                      #####....#####                      ' 
		'                     ###..........###                     ' 
		'                    ###............###                    ' 
		'                    ##..............##                    ' 
		'                   ###..............###                   ' 
		'                   ##................##                   ' 
		'                   ##................##                   ' 
		'                   ##................##                   ' 
		'                   ##................##                   ' 
		'                   ##................##                   ' 
		'                   ##................##                   ' 
		'                   ###..............###                   ' 
		'                    ##..............##                    ' 
		'                    ###............###                    ' 
		'                     ####........####                     ' 
		'                     ####........####                     ' 
		'                   ####............####                   ' 
		'                  ###................###                  ' 
		'                 ###..................###                 ' 
		'                ###....................###                ' 
		'               ###......................###               ' 
		'               ##........................##               ' 
		'              ###........................###              ' 
		'              ##..........................##              ' 
		'             ###..........................###             ' 
		'             ##............................##             ' 
		'             ##............................##             ' 
		'            ###............................###            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##################################            ' 
		'            ##################################            ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '

	).	
	^peon
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 15:07'!
reina
	"Retorna la Figura de una reina"
	
	| reina |
	reina  := AjPicture new.
	reina  init: #(
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                            ##                            ' 
		'                          ######                          ' 
		'              #####      ###..###      #####              ' 
		'             #######     ##....##     #######             ' 
		'             ##...##     ##....##     ##...##             ' 
		'             ##...##     ########     ##...##             ' 
		'    ##       ##...##      ######      ##...##       ##    ' 
		'  ######     #######        ##        #######     ######  ' 
		' ###..###     #####        ####        #####     ###..### ' 
		' ##....##       ###        ####        ###       ##....## ' 
		' ###...##       ###        ####        ###       ##...### ' 
		'  #######       ###        ####        ###       #######  ' 
		'   #####        ####      ######      ####        #####   ' 
		'     ###        ####      ##..##      ####        ###     ' 
		'     ####       ####      ##..##      ####       ####     ' 
		'     ####       #####     ##..##     #####       ####     ' 
		'     #####      ##.##     ##..##     ##.##      #####     ' 
		'      #####     ##.##    ###..###    ##.##     #####      ' 
		'      ##.##    ###.###   ##....##   ###.###    ##.##      ' 
		'      ##.###   ##...##   ##....##   ##...##   ###.##      ' 
		'      ##..##   ##...###  ##....##  ###...##   ##..##      ' 
		'      ##..###  ##....## ###....### ##....##  ###..##      ' 
		'      ###..##  ##....## ##......## ##....##  ##..###      ' 
		'       ##..### ##....#####......#####....## ###..##       ' 
		'       ##...#####.....####......####.....#####...##       ' 
		'       ##....####.....####......####.....####....##       ' 
		'       ##....####..#..###..####..###..#..####....##       ' 
		'       ###....###.######################.###....###       ' 
		'        ##.################....################.##        ' 
		'        ##########......................##########        ' 
		'        ###....................................###        ' 
		'         ##....................................##         ' 
		'         ###..................................###         ' 
		'          ###.......##################.......###          ' 
		'           ####################################           ' 
		'            ########..................########            ' 
		'            ###............................###            ' 
		'             ##............................##             ' 
		'             ##......################......##             ' 
		'             ################################             ' 
		'             ########................########             ' 
		'             ##............................##             ' 
		'            ###.....##################.....###            ' 
		'            ##################################            ' 
		'           #########..................#########           ' 
		'           ##................................##           ' 
		'           ##................................##           ' 
		'           #########..................#########           ' 
		'             ################################             ' 
		'                    ##################                    ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '

	).	
	^reina
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 19:51'!
repetirH: imagen n: n
	"Devuelve una nueva figura repitiendo la figura actual al lado la cantidad de veces que indique el valor de n"
	
	| width height newImagen oldMatrix newMatrix  |
	width := imagen getWidth  .
	height := imagen getHeight .
	oldMatrix  := imagen getMatrix .
	newMatrix  := Array new: height .
	
	1 to: height do:[
		:i |  |cadena| cadena:= newMatrix  at: i.
		
		0 to: (n-1) do:[
			: j |  newMatrix  at: (i+(width*j) ) put: cadena.
			].		
		].
	newImagen := AjPicture new.
	^ ( newImagen init: newMatrix ).
	! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 16:54'!
repetirV: imagen n: n
	"Devuelve una nueva figura repitiendo la figura actual debajo la cantidad de veces que indique el valor de n"
	
	| width height newImagen newMatrix auxImagen  |
	width := imagen getWidth  .
	height := imagen getHeight .
	auxImagen := imagen getMatrix .
	newMatrix  := Array new: (n*height) .
	
	1 to: height do:[
		:i |  |cadena| cadena:= auxImagen at: i.
		
		0 to: (n-1) do:[
			: j |  newMatrix  at: (i+(width*j) ) put: cadena.
			].		
		].
	newImagen := AjPicture new.
	^ ( newImagen init: newMatrix ).
	! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 19:13'!
rey 
	"Retorna la Figura de un rey"
	
	| rey |
	rey  := AjPicture new.
	rey init: #(
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                           ####                           ' 
		'                           #..#                           ' 
		'                           #..#                           ' 
		'                         ###..###                         ' 
		'                         #......#                         ' 
		'                         ###..###                         ' 
		'                           #..#                           ' 
		'                           #..#                           ' 
		'                           #..#                           ' 
		'                           #..#                           ' 
		'                           #..#                           ' 
		'                          ######                          ' 
		'                         ###..###                         ' 
		'                         ##....##                         ' 
		'                        ###....###                        ' 
		'           #######      ##......##      #######           ' 
		'         ###########    ##......##    ###########         ' 
		'       ####.......####  ##......##  ####.......####       ' 
		'      ###...........######......######...........###      ' 
		'     ###..............####......####..............###     ' 
		'     ##................####....####................##     ' 
		'    ###.................###....###.................###    ' 
		'    ##...................###..###...................##    ' 
		'    ##...................###..###...................##    ' 
		'    ##....................######....................##    ' 
		'    ##....................######....................##    ' 
		'    ##.....................####.....................##    ' 
		'    ###....................####....................###    ' 
		'     ##.....................##....................###     ' 
		'     ###....................##....................##      ' 
		'      ###...................##...................###      ' 
		'       ###..................##..................###       ' 
		'        ###...........##############...........###        ' 
		'         ###.....########################.....###         ' 
		'          ############..............############          ' 
		'           ######........................######           ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##........##############........##            ' 
		'            ##...########################...##            ' 
		'            ##########..............##########            ' 
		'            #####........................#####            ' 
		'            ##.........############.........##            ' 
		'            ##....######################....##            ' 
		'            ##.########............########.##            ' 
		'            ######......................######            ' 
		'            ######......................######            ' 
		'               ########............########               ' 
		'                  ######################                  ' 
		'                       ############                       ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '

	).	
	^rey
! !

!AjPicture class methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 15:03'!
torre
	"Retorna la Figura de una torre"
	
	| torre |
	torre := AjPicture new.
	torre init: #(
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'           #########     ########     #########           ' 
		'           #########     ########     #########           ' 
		'           ##.....##     ##....##     ##.....##           ' 
		'           ##.....##     ##....##     ##.....##           '
		'           ##.....#########....#########.....##           ' 
		'           ##.....#########....#########.....##           ' 
		'           ##................................##           ' 
		'           ####################################           ' 
		'           ####################################           ' 
		'            ###............................###            ' 
		'             ####........................####             ' 
		'               ############################               ' 
		'                ##########################                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##......................##                ' 
		'                ##########################                ' 
		'               ############################               ' 
		'              ###........................###              ' 
		'            ##################################            ' 
		'            ##################################            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'            ##..............................##            ' 
		'        ##########################################        ' 
		'        ##########################################        ' 
		'        ##......................................##        ' 
		'        ##########################################        ' 
		'        ##########################################        ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          ' 
		'                                                          '
	).	
	^torre
! !

!AjPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 12:29'!
getHeight 
	"Devuelve la altura de la imagen"

	^height ! !

!AjPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 12:29'!
getMatrix 
	"Devuelve la matriz que representa la imagen"

	^matrix ! !

!AjPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 12:29'!
getWidth 
	"Devuelve el ancho de la imagen"

	^width! !

!AjPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 12:40'!
init: newMatrix
	"Cambia los datos de matrix por newMatrix que representa los datos de una nueva imagen"

	matrix := newMatrix .
	width := ( newMatrix at: 1 ) size .
	height := newMatrix size 
	! !

!AjPicture methodsFor: 'as yet unclassified' stamp: 'ymq 10/18/2012 12:21'!
initialize 
	"Inicializamos la clase base y creamos una imagen vacia"

	super initialize.
	matrix := #( '' ) .
	width := 0 .
	height  :=0 ! !

Object subclass: #Picture
	instanceVariableNames: 'matrix ancho altura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Picture class methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 13:56'!
caballo
	"Retorna una matrix de un caballo"
	
	| caballo |
	caballo := #(
		'                                                           '
	  	'                                                           '
       	'                                                           ' 
        	'                                                           '
        	'                                                           '
        	'               #         ##                                ' 
        	'              ###       ####                               ' 
        	'              #####     ####                               ' 
        	'               #####   ######                              ' 
        	'               ## ### ###  ##                              ' 
        	'               ##  #####   ######                          ' 
        	'               ##   ####   #########                       ' 
        	'               ##  #####   ##   ######                     ' 
        	'              ### ###       #     ######                   ' 
        	'             ###  #                 #####                  ' 
        	'            ###                       ####                 ' 
        	'            ##                         ####                ' 
        	'           ###  ####                    ####               ' 
        	'           ##  ####                      ####              ' 
        	'           ##  ####                      #####             ' 
        	'           ##  ###                        ####             ' 
        	'	          ###  #              ##           ####            ' 
        	'          ##                  ##           ####            ' 
        	'          ##                  ##            ####           ' 
        	'         ###                  ##            ####           ' 
        	'         ##                   ##             ####          ' 
        	'        ###                  ###             ####          ' 
        	'       ###                  ###              ####          ' 
        	'      ###                   ###               ####         ' 
        	'      ##                   ####               ####         ' 
        	'     ###                 ######               ####         ' 
        	'     ##                ####  ##                ####        ' 
        	'    ### ##           ####    ##                ####        ' 
        	'    ## ###         ####     ###                ####        ' 
        	'    ## ###        ###       ##                 ####        ' 
        	'    ## ##        ###       ###                 #####       ' 
        	'    ##      ##  ###        ##                   ####       ' 
        	'    ##     ### ###        ###                   ####       ' 
        	'    ###   #######        ###                    ####       ' 
        	'     ######## ##        ###                     ####       ' 
        	'       #########       ###                      ####       ' 
        	'            ###       ###                       #####      ' 
        	'                     ###                        #####      ' 
        	'                    ###                          ####      ' 
        	'                    ##                           ####      ' 
        	'                   ###                           ####      ' 
        	'                  ###                            ####      ' 
        	'                  ##                             ####      ' 
        	'                 ###                             ####      ' 
        	'                 ##                              ####      ' 
        	'                 ##                              ####      ' 
        	'                 ####################################      ' 
        	'                 ####################################      ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           '
	).	
	^caballo
! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:21'!
initialize
	"Crea una matriz que representara una imagen con dimensiones especificadas por wh"
	
	super initialize .
	

	
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:32'!
setMatrix: newMatrix
	"Recibe la matrix que contiene los datos de la imagen a"
	
	matrix := newMatrix 
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:26'!
sizeMatrix: wh
	"Inicializa la matrix con espacios en blanco"

	|defaultString|
	ancho := wh x.
	altura := wh y.
	matrix := Array new: altura .
	
	defaultString  := String new: ancho .
	1 to: ancho do: [ : i | defaultString at: i put: (Character value: 32) ].
	
	1 to: altura do: [ :j | matrix at: j put: defaultString ].! !

Object subclass: #Picture1
	instanceVariableNames: 'img height width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Picture1 class methodsFor: 'as yet unclassified' stamp: 'david 10/12/2012 17:33'!
alfil
	|alfil imagen |
	
   imagen:=Array  new: 58.
	
    imagen atWrap: 1 put: '                                                          '.
    imagen atWrap: 2 put: '                                                          '.
    imagen atWrap: 3 put: '                                                          '.
    imagen atWrap: 4 put: '                                                          '.
    imagen atWrap: 5 put: '                            ##                            '.
    imagen atWrap: 6 put: '                          ######                          '.
    imagen atWrap: 7 put: '                         ###..###                         '.
    imagen atWrap: 8 put: '                         ##....##                         '.
    imagen atWrap: 9 put: '                         ##....##                         '.
    imagen atWrap:10 put: '                         ###..###                         '.
    imagen atWrap:11 put: '                          ######                          '.
    imagen atWrap:12 put: '                           ####                           '.
    imagen atWrap:13 put: '                         ########                         '.
    imagen atWrap:14 put: '                        ###....###                        '.
    imagen atWrap:15 put: '                      ####......####                      '.
    imagen atWrap:16 put: '                    ####..........####                    '.
    imagen atWrap:17 put: '                   ###..............###                   '.
    imagen atWrap:18 put: '                  ###................###                  '.
    imagen atWrap:19 put: '                 ###..................###                 '.
    imagen atWrap:20 put: '                ###.........##.........###                '.
    imagen atWrap:21 put: '                ##..........##..........##                '.
    imagen atWrap:22 put: '               ###..........##..........###               '.
    imagen atWrap:23 put: '               ##...........##...........##               '.
    imagen atWrap:24 put: '               ##.......##########.......##               '.
    imagen atWrap:25 put: '               ##.......##########.......##               '.
    imagen atWrap:26 put: '               ##...........##...........##               '.
    imagen atWrap:27 put: '               ##...........##...........##               '.
    imagen atWrap:28 put: '               ##...........##...........##               '.
    imagen atWrap:29 put: '               ###..........##..........###               '.
    imagen atWrap:30 put: '                ##..........##..........##                '.
    imagen atWrap:31 put: '                ###....................###                '.
    imagen atWrap:32 put: '                 ##....................###                '.
    imagen atWrap:33 put: '                 ###..................###                 '.
    imagen atWrap:34 put: '                  ###................###                  '.
    imagen atWrap:35 put: '                   ####################                   '.
    imagen atWrap:36 put: '                   ####################                   '.
    imagen atWrap:37 put: '                   ##................##                   '.
    imagen atWrap:38 put: '                  ###................###                  '.
    imagen atWrap:39 put: '                  ##..................##                  '.
    imagen atWrap:40 put: '                  ######################                  '.
    imagen atWrap:41 put: '                 ########################                 '.
    imagen atWrap:42 put: '                 ###..................###                 '.
    imagen atWrap:43 put: '                 #####..............#####                 '.
    imagen atWrap:44 put: '                 ########################                 '.
    imagen atWrap:45 put: '                      ##############                      '.
    imagen atWrap:46 put: '                          ######                          '.
    imagen atWrap:47 put: '                        ####..####                        '.
    imagen atWrap:48 put: '        ##################......##################        '.
    imagen atWrap:49 put: '      ##################..........##################      '.
    imagen atWrap:50 put: '    ####..........................................####    '.
    imagen atWrap:51 put: '    ###.....................##.....................###    '.
    imagen atWrap:52 put: '     ##...................######...................##     '.
    imagen atWrap:53 put: '     ###.########.......####  ####.......########.###     '.
    imagen atWrap:54 put: '      ####################      ####################      '.
    imagen atWrap:55 put: '       ##        #######          #######        ##       '.
    imagen atWrap:56 put: '                                                          '.
    imagen atWrap:57 put: '                                                          '.
    imagen atWrap:58 put: '                                                          '.

    alfil := Picture1 new.
    alfil init: imagen.
    ^alfil.
! !

!Picture1 class methodsFor: 'as yet unclassified' stamp: 'david 10/12/2012 17:33'!
rey
	|rey imagen |
	
	imagen:=Array  new: 58.
	   imagen atWrap:  1 put: '                                                          '.
       imagen atWrap:  2 put: '                                                          '.
       imagen atWrap:  3 put: '                                                          '.
       imagen atWrap:  4 put: '                                                          '.
       imagen atWrap:  5 put: '                           ####                           '.
       imagen atWrap:  6 put: '                           #..#                           '.
       imagen atWrap:  7 put: '                           #..#                           '.
       imagen atWrap:  8 put: '                         ###..###                         '.
       imagen atWrap:  9 put: '                         #......#                         '.
       imagen atWrap: 10 put: '                         ###..###                         '.
       imagen atWrap: 11 put: '                           #..#                           '.
       imagen atWrap: 12 put: '                           #..#                           '.
       imagen atWrap: 13 put: '                           #..#                           '.
       imagen atWrap: 14 put: '                           #..#                           '.
       imagen atWrap: 15 put: '                           #..#                           '.
       imagen atWrap: 16 put: '                          ######                          '.
       imagen atWrap: 17 put: '                         ###..###                         '.
       imagen atWrap: 18 put: '                         ##....##                         '.
       imagen atWrap: 19 put: '                        ###....###                        '.
       imagen atWrap: 20 put: '           #######      ##......##      #######           '.
       imagen atWrap: 21 put: '         ###########    ##......##    ###########         '.
       imagen atWrap: 22 put: '       ####.......####  ##......##  ####.......####       '.
       imagen atWrap: 23 put: '      ###...........######......######...........###      '.
       imagen atWrap: 24 put: '     ###..............####......####..............###     '.
       imagen atWrap: 25 put: '     ##................####....####................##     '.
       imagen atWrap: 26 put: '    ###.................###....###.................###    '.
       imagen atWrap: 27 put: '    ##...................###..###...................##    '.
       imagen atWrap: 28 put: '    ##...................###..###...................##    '.
       imagen atWrap: 29 put: '    ##....................######....................##    '.
       imagen atWrap: 30 put: '    ##....................######....................##    '.
       imagen atWrap: 31 put: '    ##.....................####.....................##    '.
       imagen atWrap: 32 put: '    ###....................####....................###    '.
       imagen atWrap: 33 put: '     ##.....................##....................###     '.
       imagen atWrap: 34 put: '     ###....................##....................##      '.
       imagen atWrap: 35 put: '      ###...................##...................###      '.
       imagen atWrap: 36 put: '       ###..................##..................###       '.
       imagen atWrap: 37 put: '        ###...........##############...........###        '.
       imagen atWrap: 38 put: '         ###.....########################.....###         '.
       imagen atWrap: 39 put: '          ############..............############          '.
       imagen atWrap: 40 put: '           ######........................######           '.
       imagen atWrap: 41 put: '            ##..............................##            '.
       imagen atWrap: 42 put: '            ##..............................##            '.
       imagen atWrap: 43 put: '            ##........##############........##            '.
       imagen atWrap: 44 put: '            ##...########################...##            '.
       imagen atWrap: 45 put: '            ##########..............##########            '.
       imagen atWrap: 46 put: '            #####........................#####            '.
       imagen atWrap: 47 put: '            ##.........############.........##            '.
       imagen atWrap: 48 put: '            ##....######################....##            '.
       imagen atWrap: 49 put: '            ##.########............########.##            '.
       imagen atWrap: 50 put: '            ######......................######            '.
       imagen atWrap: 51 put: '            ######......................######            '.
       imagen atWrap: 52 put: '               ########............########               '.
       imagen atWrap: 53 put: '                  ######################                  '.
       imagen atWrap: 54 put: '                       ############                       '.
       imagen atWrap: 55 put: '                                                          '.
       imagen atWrap: 56 put: '                                                          '.
       imagen atWrap: 57 put: '                                                          '.
       imagen atWrap: 58 put: '                                                          '.
	   
	   rey := Picture1 new.
	   rey init: imagen.
       ^rey.! !

!Picture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/11/2012 23:03'!
getHeight
	^height.
	! !

!Picture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/11/2012 23:03'!
getWidth
	^width .
	! !

!Picture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/11/2012 23:02'!
getimg
	^img.! !

!Picture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/11/2012 22:59'!
init: pic
	|cadena |
 	img := pic.
	height := pic size.
	cadena :=  pic at:1.
	width := cadena size! !

!Picture1 methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 10/11/2012 22:14'!
initialize 
	super initialize.! !
